unit JoinVobFilesUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ShellAPI, ExtCtrls, Menus;

const
  WM_NOTIFYICON  = WM_USER+333;


type
  TAppForm = class(TForm)
    AddVOBFilesGroupBox: TGroupBox;
    OutputFileGroupBox: TGroupBox;
    JoinProcessInfoGroupBox: TGroupBox;
    VOBFilesListBox: TListBox;
    AddVOBFileButton: TButton;
    RemoveVOBFileButton: TButton;
    JoinVOBFilesButton: TButton;
    MinimizeToTrayButton: TButton;
    OutputFileNameEdit: TEdit;
    ChangeOutputFileNameButton: TButton;
    JoinProcessProgressBar: TProgressBar;
    JoinProcessProgressLabel: TLabel;
    OpenVOBFileDialog: TOpenDialog;
    ChangeFileNameSaveDialog: TSaveDialog;
    ProgressTimer: TTimer;
    CancelButton: TButton;
    AppMenu: TMainMenu;
    Help1: TMenuItem;
    OnlineHelp1: TMenuItem;
    procedure MinimizeToTrayButtonClick(Sender: TObject);
    procedure AddVOBFileButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RemoveVOBFileButtonClick(Sender: TObject);
    procedure ChangeOutputFileNameButtonClick(Sender: TObject);
    procedure JoinVOBFilesButtonClick(Sender: TObject);
    procedure ProgressTimerTimer(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure OnlineHelp1Click(Sender: TObject);
  private
    { Private declarations }
    tnid: TNotifyIconData;
    HMainIcon: HICON;
    procedure CMClickIcon(var msg: TMessage); message WM_NOTIFYICON;
    public
    { Public declarations }
  end;

var
  AppForm: TAppForm;
  CurrFileName,FullOutputFileName,SummaryLine,CommandProcLine:string;
  i,FilesCount,BrowseFiles,CurrPercent:integer;
  VOBFilesOpened:TStrings;
  SummaryFilesLen,OutputFileLen:Int64;
  ts:TSearchRec;
  si: STARTUPINFO;
  pi: PROCESS_INFORMATION;
  hProc:Thandle;
  ProcState:DWORD;



implementation

{$R *.dfm}

procedure TAppForm.CMClickIcon(var msg: TMessage);
begin
  if msg.lparam=WM_LBUTTONDBLCLK then
      begin
        Show;
        Shell_NotifyIcon(NIM_DELETE, @tnid);
      end;
end;


procedure TAppForm.MinimizeToTrayButtonClick(Sender: TObject);
begin
HMainIcon:= LoadIcon(MainInstance, 'MAINICON');

  Shell_NotifyIcon(NIM_DELETE, @tnid);

  tnid.cbSize              := sizeof(TNotifyIconData);
  tnid.Wnd                 := handle;
  tnid.uID                 := 123;
  tnid.uFlags              := NIF_MESSAGE or NIF_ICON or NIF_TIP;
  tnid.uCallbackMessage    := WM_NOTIFYICON;
  tnid.hIcon               := HMainIcon;
  tnid.szTip               := 'Join VOB Files Tool';

  Shell_NotifyIcon(NIM_ADD, @tnid);
  AppForm.Hide;
end;

procedure TAppForm.AddVOBFileButtonClick(Sender: TObject);
begin
if OpenVOBFileDialog.Execute then
  begin
  VOBFilesOpened:=OpenVOBFileDialog.Files;
  BrowseFiles:=VOBFilesOpened.Count;
  for i:=1 to BrowseFiles do
    begin
    inc(FilesCount);
    CurrFileName:=VOBFilesOpened.Strings[i-1];
    VOBFilesListBox.Items.Add(CurrFileName);
    VOBFilesListBox.ItemIndex:=FilesCount-1;
    end;
  end;
end;

procedure TAppForm.FormCreate(Sender: TObject);
begin
FilesCount:=0;
CurrFileName:='';
FullOutputFileName:='C:\joined.VOB';
SummaryFilesLen:=0;
SummaryLine:='';
end;

procedure TAppForm.RemoveVOBFileButtonClick(Sender: TObject);
begin
VOBFilesListBox.Items.Delete(VOBFilesListBox.ItemIndex);
end;

procedure TAppForm.ChangeOutputFileNameButtonClick(Sender: TObject);
begin
if ChangeFileNameSaveDialog.Execute then
  begin
  FullOutputFileName:=ChangeFileNameSaveDialog.FileName;
  OutputFileNameEdit.Text:=FullOutputFileName;
  end;

end;

procedure TAppForm.JoinVOBFilesButtonClick(Sender: TObject);
begin
AddVOBFileButton.Enabled:=false;
RemoveVOBFileButton.Enabled:=false;
JoinVOBFilesButton.Enabled:=false;
VOBFilesListBox.Enabled:=false;
OutputFileNameEdit.Enabled:=false;
ChangeOutputFileNameButton.Enabled:=false;
// Summary file length
for i:=1 to VOBFilesListBox.Count do
  begin
  FindFirst(VOBFilesListBox.Items.Strings[i-1],faAnyFile,ts);
  SummaryFilesLen:=SummaryFilesLen+ts.FindData.nFileSizeHigh*4294967296+ts.FindData.nFileSizeLow;
  if i<>VOBFilesListBox.Count
    then
    SummaryLine:=SummaryLine+'/Y /B "'+VOBFilesListBox.Items.Strings[i-1]+'" + '
    else
    SummaryLine:=SummaryLine+'/Y /B "'+VOBFilesListBox.Items.Strings[i-1]+'"  ';
  end;
// Run files joining
ZeroMemory(@si, sizeof(si));
si.cb := sizeof(si);
si.dwFlags:=STARTF_USESHOWWINDOW;
si.wShowWindow:=SW_HIDE;
CommandProcLine:='copy '+SummaryLine+' "'+FullOutputFileName+'"';
CreateProcess(nil,PChar('cmd.exe /C '+CommandProcLine),nil, nil, false, 0, nil, nil, si, pi);
CloseHandle(pi.hThread);
hProc:=pi.hProcess;
ProgressTimer.Enabled:=true;
end;

procedure TAppForm.ProgressTimerTimer(Sender: TObject);
begin
CancelButton.Enabled:=true;
JoinProcessInfoGroupBox.Caption:=' Joining ... ';
ProcState:=WaitForSingleObject(hProc,50);
If ProcState<>WAIT_OBJECT_0 then
  begin
  FindFirst(FullOutputFileName,faAnyFile,ts);
  OutputFileLen:=ts.FindData.nFileSizeHigh*4294967296+ts.FindData.nFileSizeLow;
  CurrPercent:=round(OutputFileLen*100/SummaryFilesLen);
  JoinProcessProgressBar.Position:=CurrPercent;
  JoinProcessProgressLabel.Caption:=inttostr(CurrPercent)+' %';
  end;
If ProcState=WAIT_OBJECT_0 then
  begin
  JoinProcessInfoGroupBox.Caption:=' Done. ';
  JoinProcessProgressBar.Position:=0;
  JoinProcessProgressLabel.Caption:='';
  AddVOBFileButton.Enabled:=true;
  RemoveVOBFileButton.Enabled:=true;
  JoinVOBFilesButton.Enabled:=true;
  VOBFilesListBox.Enabled:=true;
  OutputFileNameEdit.Enabled:=true;
  ChangeOutputFileNameButton.Enabled:=true;
  FilesCount:=0;
  CurrFileName:='';
  SummaryFilesLen:=0;
  SummaryLine:='';
  CancelButton.Enabled:=false;
  ProgressTimer.Enabled:=false;
  end;


end;

procedure TAppForm.CancelButtonClick(Sender: TObject);
begin
if MessageDlg('Are you sure to Cancel process?',
    mtConfirmation, [mbYes, mbNo],1) = mrYes then
    begin
    TerminateProcess(hProc,0);
    end;
end;

procedure TAppForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
if MessageDlg('Are you sure to exit?',
mtConfirmation, [mbOk, mbCancel], 0) = mrCancel then
  begin
  CanClose := False;
  end
  else
  begin
  if hProc<>0 then TerminateProcess(hProc,0);
  CanClose := True;
  end;
end;

procedure TAppForm.OnlineHelp1Click(Sender: TObject);
begin
ShellExecute(0, nil, PChar('http://beginwithsoftware.com/videoguides/joinvobfilestool.html'), nil, nil, SW_SHOWNORMAL);
end;

end.
